'// Pix3D
'// GDImage/OpenGL project
'// Created by Patrice TERRIER on december 31, 2014
'// Last revision january 4, 2015

#COMPILE EXE "pix3D.exe"
#INCLUDE     "Windows.inc"
#INCLUDE     "GL.inc"
#INCLUDE     "GDImage.inc"
#RESOURCE    "zapdpi.pbr"

#INCLUDE     "WinLIFT.inc"

declare function PathCombine lib "SHLWAPI.DLL" alias "PathCombineA" (byref lpszDest as asciiz, byref lpszDir as asciiz, byref lpszFile as asciiz) as long
declare function zTrace lib "zTrace.DLL" alias "zTrace" (zMessage as asciiz) as long

%TBS_AUTOTICKS = &H0001
%TBS_VERT      = &H0002
%TBS_BOTTOM    = &H0000
%TBM_GETPOS    = %WM_USER
%TBM_SETPOS    = %WM_USER + 5
%TBM_SETRANGE  = %WM_USER + 6
%WM_APPLYFOCUS = %WM_USER + 999

%SceneWidth    = 1330	'// Do not alter this value it is the maximum OpenGL scene width.
%SceneHeight   = 1330	'// Do not alter this value it is the maximum OpenGL scene height.

%ClientW       = 840
%ClientH       = 600

%TIMER_DELAY   = 33

%IDC_OGLCTRL   = -1
%IDC_TIMER     = 1
%IDC_USINGIT   = 2
%IDC_LABEL     = 3
%IDC_ANIMATE   = 4
%IDC_ZOOMING   = 5
%IDC_RESTORE   = 6
%IDC_PALETTE   = 7
%IDC_LISTBOX   = 8

type PROP
    usefont           as dword
    hinstance         as dword
    hMain             as dword
    hGL               as dword
    procGL            as dword
    minTrackSizeW     as long
    minTrackSizeH     as long

    mt                as ZGLTEXTUREX

    mouseLastPos      as POINT
    mouseDown         as POINT
    leftMousing       as long
    rightMousing      as long
    rXcopy            as single
    rYcopy            as single
    nXdown            as long
    nYdown            as long
    nWasXL            as long
    nWasYL            as long
    nWasXR            as long
    nWasYR            as long

    colorWhite        as long
    pix3D             as long
    done              as long
    palette           as long
end type

global gP as PROP

function dpi(byval nPix as long) as long
    static ratio as single
    if (ratio = 0) then
        local hDC as DWORD
        hDC = GetDC(%NULL): ratio = (GetDeviceCaps(hDC, %LOGPIXELSX) / 96): ReleaseDC(%NULL, hDC)
    end if
    function = clng(nPix * ratio)
end function

function addLabel(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(0, "Static", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if (hCtrl) then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

function addButton(byval hParent as dword, byval nID as long, zCaption as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, byval dwStyle as dword) as dword
    local hCtrl as dword
    hCtrl = CreateWindowEx(0, "Button", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, nID, gP.hinstance, byval %NULL)
    if (hCtrl) then SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
    function = hCtrl
end function

function EXEpath() as string
    static zPath as asciiz * %MAX_PATH
    local nLen as long: nLen = len(zPath)
    if (nLen = 0) then
        if (GetModuleFileName(byval %NULL, zPath, sizeof(zPath))) then
            local pBits as byte ptr
            local K as long
            nLen = len(zPath)
            pBits = varptr(zPath) + nLen
            for K = 1 to nLen
                if (@pBits[-K] <> 92) then
                    @pBits[-K] = 0
                else
                    exit for
                end if
            next
        end if
    end if
    function = zPath
end function

function EXEresource() as string
    static szResource as asciiz * %MAX_PATH
    if (len(szResource) = 0) then PathCombine(szResource, EXEpath(), "resource\")
    function = szResource
end function

sub List_DeleteAll(byval hList as dword)
    if (IsWindow(hList)) then SendMessage(hList, %LB_RESETCONTENT, 0, 0)
end sub

sub List_SelectPlus(byval hList as dword, byval nSelected as long)
    if (nSelected > 0) then decr nSelected '// Because ListBox is zero based
    if (IsWindow(hList)) then SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
end sub

function List_Add(byval hList as dword, zTmp as asciiz) as long
    if (IsWindow(hList)) then
        if (len(zTmp)) then function = SendMessage(hList, %LB_ADDSTRING, 0, varptr(zTmp))
    end if
end function

function List_FindString(byval hList as dword, zTmp as asciiz) as long
    local nIndex as long
    if (IsWindow(hList)) then
        nIndex = SendMessage(hList, %LB_FINDSTRINGEXACT, -1, varptr(zTmp))
        if (nIndex > -1) then nIndex += 1
    end if
    function = nIndex
end function

function List_GetCount(byval hList as dword) as long
    local nRet as long
    if (IsWindow(hList)) then nRet = SendMessage(hList, %LB_GETCOUNT, 0, 0)
    function = nRet
end function

function List_GetCursel(byval hList as dword) as long
    local nSelected as long
    if (IsWindow(hList)) then
        nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
        if (nSelected > -1) then incr nSelected '// Because ListBox is zero based
    end if
    function = nSelected
end function

function List_GetText(byval hList as dword, byval nItem as long) as string
    local sItem as string, nLen as long
    if (nItem > 0) then
        decr nItem
        nLen = SendMessage(hList, %LB_GETTEXTLEN, nItem, 0)
        sItem = space$(nLen)
        SendMessage(hList, %LB_GETTEXT, nItem, byval STRPTR(sItem))
        function = sItem
    end if
end function

function DetectImageExtension(zFileName as asciiz) as long
    local nRet, So as long
    local sExt as string
    CharLower(zFileName)
    sExt = "."
    So = instr(-1, zFileName, sExt)
    if (So) then
        sExt = mid$(zFileName, So) + sExt
        if (instr(1, ".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", sExt)) then nRet = -1
    end if
    function = nRet
end function

sub gl_LoadPalette(byval hList as dword)
    if (IsWindow(hList)) then
        local nCount, nFound as long
        local fd as WIN32_FIND_DATA
    
        List_DeleteAll(hList)

        nCount = 0
        local hFind as dword
        hFind = FindFirstFile(EXEresource() + "pal_*.png", fd)
        if (hFind <> %INVALID_HANDLE_VALUE) then
            local IsOk as long
            IsOk = -1
            while (IsOk)
                if (NOT (fd.dwFileAttributes and %FILE_ATTRIBUTE_DIRECTORY)) then
                    charLower(fd.cFileName)
                    if (List_Add(hList, fd.cFileName) > -1) then nCount += 1
                end if
                if (FindNextFile(hFind, fd) = 0) then IsOk = 0
            wend
            FindClose(hFind)
        end if
        if (nCount > 0) then
            nFound = List_FindString(hList, "pal__image.png")
            if (nFound = 0) then nFound = 1
            List_SelectPlus(hList, nFound)
        end if
    end if
end sub

sub gl_LoadTexture(byval hList as dword)
    if (IsWindow(hList)) then
        local nCount as long
        local fd as WIN32_FIND_DATA
    
        List_DeleteAll(hList)

        nCount = 0
        local hFind as dword
        hFind = FindFirstFile(EXEresource() + "image*.png", fd)
        if (hFind <> %INVALID_HANDLE_VALUE) then
            local IsOk as long
            IsOk = -1
            while (IsOk)
                if (NOT (fd.dwFileAttributes and %FILE_ATTRIBUTE_DIRECTORY)) then
                    if (List_Add(hList, fd.cFileName) > -1) then nCount += 1
                end if
                if (FindNextFile(hFind, fd) = 0) then IsOk = 0
            wend
            FindClose(hFind)
        end if
        if (nCount > 0) then List_SelectPlus(hList, 1)
    end if
end sub

sub gl_DestroyTexture()
    if (gP.mt.texture) then glDeleteTextures(1, gP.mt.texture)
end sub

'// Draw an OpenGL line between two points using a specific ARGB color and pen size.
'// Trace une ligne OpenGL entre deux points en utilisant une couleur ARGB et un trait dont l'paisseur correspond  la taille du stylo .
sub gl_dLine(byval rX1 as single, byval rY1 as single, byval rX2 as single, byval rY2 as single, byval nARGB as long, byval rSize as single)
    local nAlpha, nRed, nGreen, nBlue as byte
    zSplitColorARGB(nARGB, nAlpha, nRed, nGreen, nBlue)
    glColor4ub(nRed, nGreen, nBlue, nAlpha)
    glLineWidth(rSize)
    glBegin(%GL_LINES)
      glVertex2f(rX1, rY1): glVertex2f(rX2, rY2)
    glEnd()
end sub

sub gl_dPoint(byval rX1 as single, byval rY1 as single, byval nARGB as long)
    local nAlpha, nRed, nGreen, nBlue as byte
    zSplitColorARGB(nARGB, nAlpha, nRed, nGreen, nBlue)
    glColor4ub(nRed, nGreen, nBlue, nAlpha)
    glBegin(%GL_POINTS)
      glVertex2f(rX1, rY1)
    glEnd()
end sub

'// Draw an OpenGL outlined rectangle, which size matches the point coordinates, using a specific ARGB color and pen size.
'// Trace le contour d'un rectangle OpenGL dont la dimension est dtermine par les coordonnes des points opposs, en utilisant une couleur ARGB et un trait dont l'paisseur correspond  la taille du stylo.
sub gl_dRectOutline(byval rX1 as single, byval rY1 as single, byval rX2 as single, byval rY2 as single, byval nARGB as long, byval rSize as single)
    local nAlpha, nRed, nGreen, nBlue as byte
    zSplitColorARGB(nARGB, nAlpha, nRed, nGreen, nBlue)
    glColor4ub(nRed, nGreen, nBlue, nAlpha)
    glLineWidth(rSize)
    glBegin(%GL_LINE_LOOP)
      glVertex2f(rX1, rY1)
      glVertex2f(rX2, rY1)
      glVertex2f(rX2, rY2)
      glVertex2f(rX1, rY2)
    glEnd()
end sub

'// Apply a texture onto the surface of an OpenGL rectangle, which size matches the point coordinates, using a specific ARGB color.
'// Applique une texture sur la surface d'un rectangle OpenGL dont la dimension est dtermine par les coordonnes des points opposs, en utilisant une couleur ARGB.
sub gl_dRectTexture(byval rX1 as single, byval rY1 as single, byval rX2 as single, byval rY2 as single, byval nARGB as long, byval nTexture as long)
    local nAlpha, nRed, nGreen, nBlue as byte
    zSplitColorARGB(nARGB, nAlpha, nRed, nGreen, nBlue)
    glColor4ub(nRed, nGreen, nBlue, nAlpha)
    glEnable(%GL_TEXTURE_2D)
    glBindTexture(%GL_TEXTURE_2D, nTexture)
    glBegin(%GL_QUADS)
      glTexCoord2f(0.0, 0.0): glVertex2f(rX1, rY1)
      glTexCoord2f(1.0, 0.0): glVertex2f(rX2, rY1)
      glTexCoord2f(1.0, 1.0): glVertex2f(rX2, rY2)
      glTexCoord2f(0.0, 1.0): glVertex2f(rX1, rY2)
    glEnd()
    glDisable(%GL_TEXTURE_2D)
end sub

sub gl_dRectFilled(byval rX1 as single, byval rY1 as single, byval rX2 as single, byval rY2 as single, byval nARGB as long, byval nTexture as long)
    local nAlpha, nRed, nGreen, nBlue as byte
    zSplitColorARGB(nARGB, nAlpha, nRed, nGreen, nBlue)
    glColor4ub(nRed, nGreen, nBlue, nAlpha)
    glBegin(%GL_QUADS)
      glVertex3f(rX1, rY1, 1.0)
      glVertex3f(rX2, rY1, 1.0)
      glVertex3f(rX2, rY2, 1.0)
      glVertex3f(rX1, rY2, 1.0)
    glEnd()
end sub

function zGetPixels(byval hBitmap as dword, byval longPtr as dword ptr) as long
    local nRet as long
    if (hBitmap) then
        local bm as BITMAP
        local y, bmBPix, nScanLine as long
        local lp as long ptr
        GetObject(hBitmap, sizeof(bm), bm)
        bmBPix = bm.bmBitsPixel \ 8
        '// Have to revert raw order
        longPtr += (bm.bmWidth * bm.bmHeight * bmBPix)
        nScanLine = bm.bmWidth * bmBPix
        for y = 1 to bm.bmHeight
            longPtr -= nScanLine
            RtlMoveMemory(byval longPtr, byval bm.bmBits, nScanLine)
            bm.bmBits += nScanLine
        next
        nRet = -1
    end if
    function = nRet
end function

sub gl_DrawScene()
    DIM PixColor(511,511) as static long
    DIM Palette(255) as static long
    DIM rAlpha(511,511) as static single
    
    static nFlip, nMove, nStep as long

    local rX1, rY1, rX2, rY2, rW, rH, rPenSize, rZoom as single
    local rSize, rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot as single
    local x, y, nW, nH, nAnimate, nPixStep, nColor as long
    local A, R, G, B as byte
    local hBitmap as dword

    nFlip = NOT nFlip: if nFlip = 0 or gP.hGL = 0 then exit sub

    nAnimate = SendMessage(GetDlgItem(gP.hMain, %IDC_ANIMATE), %BM_GETCHECK, 0, 0)
    if (nAnimate) then
        if (nMove > 5) then
            nStep = -1 
        elseif nMove < 1 then
            nStep = 1
        end if
        nMove += nStep
    else 
        nMove = 2: nStep = 1
    end if

    if (gP.palette = 0) then 
        local hPalette as dword, szPalette as asciiz * %MAX_PATH
        hPalette = GetDlgItem(gP.hMain, %IDC_PALETTE)
        PathCombine(szPalette, EXEresource(), List_GetText(hPalette, List_GetCursel(hPalette)))
        hBitmap = ZI_CreateBitmapFromFile(szPalette, nW, nH)
        if (hBitmap) then
            '//zGetDIBits(hBitmap, Palette())
            zGetPixels(hBitmap, byval varptr(Palette(0,0)))
            DeleteObject(hBitmap)
        end if
        if (nAnimate = 0) then nMove = 2: nStep = 1
        nAnimate = 0
    end if

    nW = 512: nH = 512
    if (gP.done = 0) then 
        hBitmap = ZI_FitBitmapFromFile(gP.mt.FullName, nW, nH)
        if (hBitmap) then
            '//zGetDIBits(hBitmap, PixColor())
            zGetPixels(hBitmap, byval varptr(PixColor(0,0)))
            DeleteObject(hBitmap)
            for y = 0 to nH - 1 '//step 2
                for x = 0 to nW -1 '//step 2
                    zSplitColorARGB(PixColor(x, y), A, R, G, B)
                    if (A) then
                        rAlpha(x,y) = sqr(Rgb2Gray(RGB(R,G,B)) AND &H000000FF???)
                    else
                        rAlpha(x,y) = 0
                    end if
                next
            next
            gP.done = -1
        end if
    end if

    rX1 = 0: rY1 = 0: rX2 = rX1 + nW - 1: rY2 = rY1 + nH - 1
    rW = nW * 0.5
    rH = nH * 0.5

    glClear(%GL_COLOR_BUFFER_BIT or %GL_DEPTH_BUFFER_BIT)

    '// Start drawing a new scene.
    '// On dbute le dessin d'une nouvelle scene.
    glLoadIdentity()

    '// Get Mousing coordinates, zooming, rotation.
    GL_ChartGetMousing(rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot)
    glTranslatef(rViewXoff, rViewYoff, rViewZoff)

    '// Zooming factor.
    rZoom = rViewZoom * -0.01
    glScalef(rZoom, rZoom, rZoom)

    '// Mousing rotation
    glRotatef(-rViewYrot, 1, 0, 0)
    glRotatef(-rViewXrot, 0, 1, 0)

    if (gP.pix3D = 0) or (gP.palette = 0) or (nAnimate) then
        if (nAnimate = 0) then
            '// Start recording displaylist
            gP.pix3D = glGenLists(1)
            glNewList(gP.pix3D, %GL_COMPILE_AND_EXECUTE)
        end if

        '// Draw a filled quadrilateral using the top left pixel color
        '// Dessine quadrilatre opaque de la couleur du pixel haut gauche.
        glPushMatrix()
          '// Apply a little translation to avoid overlapping the opaque quadrilateral.
          glTranslatef(0, 0, -2.0) '// TRANSLATION
          nColor = PixColor(0, 0): if (nColor = 0) then nColor = ZD_ARGB(255, 0, 0, 0)
          gl_dRectFilled(rX1 - rW, rY1 - rH, rX2 -rW, rY2 - rH, nColor, 0)
        glPopMatrix()

        glPushMatrix()
          glRotatef(90, 1, 0, 0)  '// ROTATION
          glTranslatef(0, 0, -rH) '// TRANSLATION
          if (nAnimate) then rPenSize = 2 else rPenSize = 1
          glPointSize(rPenSize)
          nPixStep = 2
          for y = 0 to nH - 1 step nPixStep
              for x = 0 to nW -1 step nPixStep
                  zSplitColorARGB(PixColor(x, y), A, R, G, B)
                  if (A) then
                      if (Palette(0)) then
                          nColor = rAlpha(x, y) * rAlpha(x, y)
                          nColor = Palette(nColor)
                      else
                          nColor = PixColor(x, y)
                      end if
                      rSize = rAlpha(x, y) * nMove + 2
                      'gl_dLine(rX1 - rW + x, rY1, rX1 - rW + x, rY1 - rSize, nColor, rPenSize)
                      gl_dPoint(rX1 - rW + x, rY1 - rSize, nColor)
                  end if
              next
              glTranslatef(0, 0, nPixStep) '// TRANSLATION
          next
        glPopMatrix()

        '// Draw a textured quadrilateral.
        '// Dessine un quadrilatre textur.
        gl_dRectTexture(rX1 - rW, rY1 - rH, rX2 -rW, rY2 - rH, gP.colorWhite, gP.mt.texture)
        '// Draw a rectangular outline.
        '// Dessine contour rectangle.
        rPenSize = 2
        gl_dRectOutline(rX1 - rW - rPenSize, rY1 - rH - rPenSize, rX2 - rW + rPenSize, rY2 - rH + rPenSize, gP.colorWhite, rPenSize)

        if (nAnimate = 0) then
            '// Stop recording displaylist
            glEndList()
        end if
        gP.palette = -1
    else
        '// Playback displaylist
        glCallList(gP.pix3D)
    end if

    '// Flush OpenGL buffer.
    glFlush()

    '// Draw the scene into the GDImage control.
    '// On dessine la scene dans le contrle GDImage.
    ZI_UpdateGLWindow(gP.hGL)
end sub

sub gl_TimerView()
    local AniCount as dword
    static AnimDelay as dword
    AniCount = GetTickCount()
    if (AnimDelay = 0) then AnimDelay = AniCount + %TIMER_DELAY
    if (AniCount > AnimDelay) then
        AnimDelay = 0
        gl_DrawScene()
        ZI_SpinnerClose()
    end if
end sub

sub gl_ResizeControl()
    local rc as RECT
    GetClientRect(gP.hGL, rc)

    glViewport((rc.right - %SceneWidth) * 0.5, (rc.bottom - %SceneHeight) * 0.5, %SceneWidth, %SceneHeight)
    glMatrixMode(%GL_PROJECTION)
    glLoadIdentity()

    '// We force OpenGL to use a resolution that is very close to 2D pixel size
    '// as long as the constant SceneWidth and SceneHeight are equal to 1330
    ''''''''gluPerspective(100, 1, 1, 1000)
    GL_Perspective(100, 1, 1, 1000)
    glTranslatef(0.375, 0.375, -557.65) '// 0.375 = Displacement trick FOR exact pixelization
    glMatrixMode(%GL_MODELVIEW)

    gl_DrawScene() '// OpenGL display
end sub

sub gl_InitView()
    local rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot as single
    rViewXoff = 0
    rViewYoff = 0
    rViewZoff = 0
    rViewZoom = -100
    SendMessage(GetDlgItem(gP.hMain, %IDC_ZOOMING), %TBM_SETPOS, 1, rViewZoom)
    rViewXrot = 0
    rViewYrot = 0

    GL_ChartSetMousing(rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot)

    SendMessage(GetDlgItem(gP.hMain, %IDC_ANIMATE), %BM_SETCHECK, %BST_UNCHECKED, 0)
end sub

function gl_WndProc(byval hWnd as dword, byval uMsg as dword, byval wParam as dword, byval lParam as long) as long

    local lp as POINT
    local nDX, nDY, nRet, nZoom as long
    local rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot as single
    local lpr as RECT

    GL_ChartGetMousing(rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot)

    select case long (uMsg)
    case %WM_LBUTTONDOWN:
         if (gP.leftMousing = %FALSE) then
             lp.x = LO(INTEGER, lParam): lp.y = HI(INTEGER, lParam)
             gP.mouseLastPos.x = lp.x
             gP.mouseDown.x = lp.x
             gP.mouseLastPos.y = lp.y
             gP.mouseDown.y = lp.y
             gP.leftMousing = %TRUE
         end if
         if (GetFocus() <> hWnd) then SetFocus(hWnd)

    case %WM_LBUTTONUP:
          gP.leftMousing = %FALSE

    case %WM_RBUTTONDOWN:
         if (gP.rightMousing = %FALSE) then
             lp.x = LO(INTEGER, lParam): lp.y = HI(INTEGER, lParam)

             gP.rXcopy = rViewXoff
             gP.rYcopy = rViewYoff

             gP.nXdown = lp.x
             gP.nYdown = lp.y

             gP.rightMousing = %TRUE
         end if

    case %WM_RBUTTONUP:
         gP.rightMousing = %FALSE

    case %WM_MOUSEWHEEL:
         nZoom = SendMessage(GetDlgItem(gP.hMain, %IDC_ZOOMING), %TBM_GETPOS, 0, 0)
         if (HI(INTEGER, wParam) < 0) then
             if (nZoom > -200 + 10) then nZoom -= 10
         else
             if (nZoom < -11) then nZoom += 10
         end if
         SendMessage(GetDlgItem(gP.hMain, %IDC_ZOOMING), %TBM_SETPOS, 1, nZoom)
         rViewZoom = nZoom
         if (GetFocus() <> hWnd) then SetFocus(hWnd)

    case %WM_MOUSEMOVE:
         lp.x = LO(INTEGER, lParam): lp.y = HI(INTEGER, lParam)
         if (gP.leftMousing) then
             if (ZI_IsLButtonDown() = 0) then
                 gP.leftMousing = %FALSE
             else
                 if ((gP.nWasXL <> lp.x) or (gP.nWasYL <> lp.y)) then
                     gP.mouseDown.x = lp.x
                     gP.mouseDown.y = lp.y

                     rViewXrot = rViewXrot - (gP.mouseDown.x - gP.mouseLastPos.x)
                     rViewYrot = rViewYrot - (gP.mouseDown.y - gP.mouseLastPos.y)

                     gP.mouseLastPos.x = gP.mouseDown.x
                     gP.mouseLastPos.y = gP.mouseDown.y
                 end if
                 gP.nWasXL = lp.x: gP.nWasYL = lp.y
             end if
         elseif (gP.rightMousing) then
             if (ZI_IsRButtonDown() = 0) then
                 gP.rightMousing = %FALSE
             else
                 if ((gP.nWasXR <> lp.x) or (gP.nWasYR <> lp.y)) then
                     GetClientRect(hWnd, lpr)
                     nDX = lp.x - gP.nXdown
                     rViewXoff = gP.rXcopy - (-0.5 * nDX)
                     nDY = lp.y - gP.nYdown
                     rViewYoff = gP.rYcopy + (-0.5 * nDY)
                 end if
                 gP.nWasXR = lp.x: gP.nWasYR = lp.y
             end if
         end if

    case %WM_DROPFILES:
         local szFile as asciiz * %MAX_PATH
         local nCount as long
         nCount = DragQueryFile(wParam, &HFFFFFFFF, "", 0)
         if (nCount) then
            if (DragQueryFile(wParam, 0, szFile, %MAX_PATH)) then
                if (DetectImageExtension(szFile)) then
                    gP.mt.FullName = szFile
                    ZI_UpdateNamedGLTextureFromFileEx(gP.mt.FullName, gP.mt.texture, gP.mt.Square)
                    gP.done = 0
                    gP.pix3D = 0
                    gl_InitView()
                    gl_DrawScene()
                    SetFocus(gP.hGL)
                end if
            end if
         end if
         DragFinish(wParam)

    end select

    GL_ChartSetMousing(rViewXoff, rViewYoff, rViewZoff, rViewZoom, rViewXrot, rViewYrot)

    if (gP.procGL) then nRet = CallWindowProc(gP.procGL, hWnd, uMsg, wParam, lParam)
    function = nRet
end function

sub gl_Initialize()
    local hCtrl as dword
    '// Create the textures.
    hCtrl = GetDlgItem(gP.hMain, %IDC_LISTBOX)
    PathCombine(gP.mt.FullName, EXEresource(), List_GetText(hCtrl, List_GetCursel(hCtrl)))
    gP.mt.ID = 1: gP.mt.Square = 1
    ZI_MakeMultipleTexture(byval varptr(gP.mt), 1)

    gP.colorWhite = ZD_ARGB(255, 255,255,255)

    glClearColor(0.5!, 0.5!, 0.5!, 1.0!) '// Grayed background, same as RGB(128,128,128)
    glClearDepth(1)
    glDepthFunc(%GL_LESS)
    glEnable(%GL_DEPTH_TEST)

    glBlendFunc(%GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA)
    glEnable(%GL_BLEND)
    glEnable(%GL_LINE_SMOOTH)

    gl_InitView()

    gP.procGL = SetWindowLong(gP.hGL, %GWL_WNDPROC, codeptr(gl_WndProc))

end sub

function WndProc(byval hWnd as dword, byval uMsg as dword, byval wParam as dword, byval lParam as long) as long

    local rZoomXoff, rZoomYoff, rZoomZoff, rZoomValue, rZoomXrot, rZoomYrot as single
    local hCtrl as dword
    static hFocus as dword

    select case long (uMsg)

    case %WM_GETMINMAXINFO:
         local pMM as MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = gP.minTrackSizeW '// minimum width size of the window.
         @pMM.ptMinTrackSize.y = gP.minTrackSizeH '// minimum height size of the window.

    case %WM_SIZE:
         gl_ResizeControl()

    case %WM_TIMER:
         'gl_DrawScene()
         gl_TimerView()
         function = 0: exit function

    case %WM_NCACTIVATE:
         '// Save the handle of the control that has the focus
         if (wParam = 0) then hFocus = GetFocus()

    case %WM_SETFOCUS:
         '// Post a message to set the focus later, since some
         '// Windows actions can steal it if we set it here
         if (hFocus) then
             PostMessage(hWnd, %WM_APPLYFOCUS, hFocus, 0)
             hFocus = 0
         end if

    case %WM_APPLYFOCUS:
         '// Set the focus
         if (wParam) then SetFocus(wParam)
         exit function

    case %WM_VSCROLL:
         if (GetDlgCtrlID(lParam) = %IDC_ZOOMING) then
             GL_ChartGetMousing(rZoomXoff, rZoomYoff, rZoomZoff, rZoomValue, rZoomXrot, rZoomYrot)
             rZoomValue = SendMessage(lParam, %TBM_GETPOS, 0, 0)
             GL_ChartSetMousing(rZoomXoff, rZoomYoff, rZoomZoff, rZoomValue, rZoomXrot, rZoomYrot)
         end if

    case %WM_COMMAND:

         '// Messages from controls and menu items are handled here.
         select case long lo(word, wParam)
         case %IDCANCEL:
              '// if the Escape key has been pressed...
              if (hi(word, wParam) = %BN_CLICKED) then
                  '// Shut down the application by sending a WM_CLOSE message
                  SendMessage(hWnd, %WM_CLOSE, 0, 0)
                  exit function
              end if

         case %IDC_ANIMATE:
              SetFocus(gP.hGL)

         case %IDC_RESTORE:
              gl_InitView()
              gl_DrawScene()
              SetFocus(gP.hGL)

         case %IDC_PALETTE:
              if (HI(WORD, wParam) = %LBN_SELCHANGE) then
                  gP.palette = 0
                  gl_DrawScene()
                  SetFocus(gP.hGL)
              end if

         case %IDC_LISTBOX:
              if (HI(WORD, wParam) = %LBN_SELCHANGE) then
                  hCtrl = GetDlgItem(hWnd, %IDC_LISTBOX)
                  PathCombine(gP.mt.FullName, EXEresource(), List_GetText(hCtrl, List_GetCursel(hCtrl)))
                  ZI_UpdateNamedGLTextureFromFileEx(gP.mt.FullName, gP.mt.texture, gP.mt.Square)
                  gP.done = 0
                  gP.pix3D = 0
                  gl_InitView()
                  gl_DrawScene()
                  SetFocus(gP.hGL)
              end if

         end select

    case %WM_DESTROY:
         KillTimer(hWnd, %IDC_TIMER)
         PostQuitMessage(0)
         exit function

    end select

    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

sub InitMainTimer(byval hMain as dword)
    SetTimer(hMain, %IDC_TIMER, 0, 0)
end sub

function WinMain (byval hInstance as dword, byval hPrevInstance as dword, byval lpszCmdLine as asciiz ptr, byval nCmdShow as long) as long
    local nRet as long
    local wcx as WNDCLASSEX, rc as RECT
    local zClass as asciiz * 8, szCaption as asciiz * %MAX_PATH
    local dwStyle, dwExStyle, hMutex as dword
    local x, y, IsInitialized as long
    local msg as tagMSG

    zClass     = "pix3D"

    hMutex = CreateMutex(byval %Null, 0, zClass)
    if (hMutex) then
        if (GetLastError = %ERROR_ALREADY_EXISTS) then
            local hFound as dword
            do
                hFound = FindWindow(zClass, ""): if hFound then exit do
                while PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): wend
            loop
            if IsIconic(hFound) then ShowWindow(hFound, %SW_RESTORE)
            SetForeGroundWindow(hFound)
            function = 0: exit function
        end if
    end if

    gP.usefont = GetStockObject(%DEFAULT_GUI_FONT) '// Tahoma
    gP.hinstance = hInstance

    wcx.cbSize = sizeof(wcx)
    IsInitialized = GetClassInfoEx(hInstance, zClass, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = 0 '// %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = codeptr(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = LoadIcon  (%NULL, byval %IDI_APPLICATION)
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_BTNSHADOW
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = varptr(zClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = %TRUE
    end if

    if (IsInitialized) then
        dwStyle = %WS_OVERLAPPEDWINDOW or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN
        dwExStyle = %WS_EX_APPWINDOW or %WS_EX_WINDOWEDGE
        SetRect(rc, 0, 0, %ClientW, %ClientH)
        AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)

        gP.minTrackSizeW = dpi(rc.right - rc.left)
        gP.minTrackSizeH = dpi(rc.bottom - rc.top)
        x = max&((GetSystemMetrics(%SM_CXSCREEN) - gP.minTrackSizeW) \ 2, 0)
        y = max&((GetSystemMetrics(%SM_CYSCREEN) - gP.minTrackSizeH) \ 2, 0)

        gP.hMain = CreateWindowEx(dwExStyle, _         '// Extended Style for The Window
                               zClass, _               '// Class Name
                               zClass, _               '// Window Title
                               dwStyle, _              '// Defined Window Style
                               x, y, _                 '// Window Position
                               gP.minTrackSizeW, _     '// Calculate Window Width
                               gP.minTrackSizeH, _     '// Calculate Window Height
                               %NULL, _                '// No Parent Window
                               %NULL, _                '// No Menu
                               hInstance, _            '// Instance
                               byval %NULL)            '// Dont Pass Anything To WM_CREATE

        if (gP.hMain) then
            '// Display a spinner animation
            PathCombine(szCaption, EXEresource(), "pix3D.ski")
            ZI_SpinnerInit(gP.hMain, szCaption, 0)

            '// Create the GDImage OpenGL window
            dwExStyle = %WS_EX_ACCEPTFILES
            dwStyle = %WS_CHILD or %WS_VISIBLE
            gP.hGL = WGL_CreateWindow(dwExStyle, dwStyle, 0, 0, dpi(700), dpi(600), gP.hMain, %IDC_OGLCTRL)
            if (IsWindow(gP.hGL)) then
                ZI_SetAnchorMode(gP.hGL, %ANCHOR_HEIGHT_WIDTH)

                '//-------------------------------------------------------
                '// Add child controls
                local hCtrl as dword
                hCtrl = addLabel(gP.hMain, %IDC_LABEL, "Use pixel animation", 726, 3, 120, 24, %WS_CHILD or %WS_VISIBLE)
                ZI_SetAnchorMode(hCtrl, %ANCHOR_RIGHT)
                hCtrl = addButton(gP.hMain, %IDC_ANIMATE, "", 710, 0, 15, 24, %WS_CHILD or %WS_VISIBLE or %BS_AUTOCHECKBOX)
                if (hCtrl) then ZI_SetAnchorMode(hCtrl, %ANCHOR_RIGHT)


                dwStyle = %WS_CHILD or %WS_VISIBLE or %TBS_VERT or %TBS_BOTTOM
                hCtrl = CreateWindowEx(0, "MSCTLS_TRACKBAR32", "", dwStyle, dpi(756), dpi(30), dpi(30), dpi(217), gP.hMain, %IDC_ZOOMING, hInstance, BYVAL %NULL)
                if (hCtrl) then 
                    SendMessage(hCtrl, %TBM_SETRANGE, 1, MAKLNG(-200, -1))
                    SendMessage(hCtrl, %TBM_SETPOS, 1, -100)
                    ZI_SetAnchorMode(hCtrl, %ANCHOR_RIGHT)
                end if

                hCtrl = addButton(gP.hMain, %IDC_RESTORE, "RESTORE", 710, 260, 120, 24, %WS_CHILD or %WS_VISIBLE)
                if (hCtrl) then ZI_SetAnchorMode(hCtrl, %ANCHOR_RIGHT)

                szCaption = "Left mouse button:|View angle.||Right mouse button:|Translation.||Mouse wheel: Zoom."
                replace "|"  with $crlf in szCaption
                hCtrl = addLabel(gP.hMain, %IDC_USINGIT, szCaption, 710, 290, 120, 98, %WS_CHILD or %WS_VISIBLE or %WS_BORDER or %SS_CENTER)
                if (hCtrl) then ZI_SetAnchorMode(hCtrl, %ANCHOR_RIGHT)

                '// Create ListBox to select palette from.
                dwStyle = %WS_CHILD or %WS_BORDER or %WS_VISIBLE or %WS_VSCROLL or %LBS_SORT or %LBS_NOTIFY or %LBS_HASSTRINGS 'or %LBS_DISABLENOSCROLL 'or %LBS_NOINTEGRALHEIGHT
                hCtrl = CreateWindowEx(0, "ListBox", "", dwStyle , dpi(710), dpi(396), dpi(120), dpi(98), gP.hMain, %IDC_PALETTE, hInstance, byval %NULL)
                if (hCtrl) then
                    SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
                    gl_LoadPalette(hCtrl)
                end if

                '// Create ListBox to select texture from.
                hCtrl = CreateWindowEx(0, "ListBox", "", dwStyle , dpi(710), dpi(486), dpi(120), dpi(98+40), gP.hMain, %IDC_LISTBOX, hInstance, byval %NULL)
                if (hCtrl) then
                    SendMessage(hCtrl, %WM_SETFONT, gP.usefont, 0)
                    gl_LoadTexture(hCtrl)
                end if
                '//-------------------------------------------------------
	              '// Setup default parameters, textures, and zooming value.
	              gl_Initialize()

                if (skInitEngine("Scaff.sks", "")) then
                    skSkinWindow(gP.hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
                    
                    GetWindowRect(gP.hMain, rc)
                    gP.minTrackSizeW = dpi(rc.right - rc.left)
                    gP.minTrackSizeH = dpi(rc.bottom - rc.top)
                    skSetAnchorCtrl(GetDlgItem(gP.hMain, %IDC_PALETTE), %ANCHOR_BOTTOM_RIGHT)
                    skSetAnchorCtrl(GetDlgItem(gP.hMain, %IDC_LISTBOX), %ANCHOR_BOTTOM_RIGHT)
                else
                    ZI_SetAnchorMode(GetDlgItem(gP.hMain, %IDC_PALETTE), %ANCHOR_BOTTOM_RIGHT)
                    ZI_SetAnchorMode(GetDlgItem(gP.hMain, %IDC_LISTBOX), %ANCHOR_BOTTOM_RIGHT)
                end if

                InitMainTimer(gP.hMain)

                ShowWindow(gP.hMain, nCmdShow)
                SetForegroundWindow(gP.hMain) '// Slightly Higher Priority
                SetFocus(gP.hMain)            '// Sets Keyboard Focus To The Window

                while GetMessage(msg, %NULL, 0, 0)
                    TranslateMessage(msg)
                    DispatchMessage(msg)
                wend

                nRet = msg.wParam

                '// Cleanup texture from memory
                gl_DestroyTexture()

            end if
        end if
    end if
    if (hMutex) then CloseHandle(hMutex)
    function = nRet
end function
